// Test2 - playing wave file

#pragma config POSCMOD=XT, FNOSC=PRIPLL, OSCIOFNC=OFF
#pragma config FPLLIDIV=DIV_4, FPLLMUL=MUL_20, FPLLODIV=DIV_1
#pragma config FPBDIV=DIV_2, FWDTEN=OFF, CP=OFF, BWP=OFF
#pragma config PWP=OFF, FSOSCEN=OFF, FCKSM=CSDCMD, JTAGEN=OFF, IESO=OFF

#include <p32xxxx.h>
#include <system.h>
#include <FSIO.h>
#include <plib.h>
#include "HardwareProfile.h"
#include "GenericTypeDefs.h"
//#include "wavePlayer.h"

#define FCY 40000000UL
#define PBS FCY/2

void UART1_Init(unsigned long);
void UART1_putc(unsigned char);
void UART1_puts(unsigned char*);
void UART1_puts_N(unsigned char*);
void delay_ms(unsigned int);

int main()
{
	SDI1R = 0x01;	//	0001 - RPB5 at RB5 (17)
	RPA1R = 0x03;   //  0011 - SDO1 at RA1 (3)
					//       - SCL1 at pin 17
	ANSELA = 0x0000;
	ANSELB = 0x0000;
	//TRISA = 0x0000;
	//TRISB = 0x0000;
	TRISBbits.TRISB2 = 0;
	
	const char fileName[] = "*.WAV";
	int FindWavFileStatus;
	int PlayWavFileStatus;

	CM1CONbits.ON = 0;
	CM2CONbits.ON = 0;
	CM3CONbits.ON = 0;
	CVRCONbits.ON = 0;
	CVRCONbits.CVROE = 0;
	CTMUCONbits.ON = 0;
	AD1CON1bits.ON = 0;
	
	PMCONbits.ON = 0;
	PMCONbits.PTWREN = 0;
	PMCONbits.PTRDEN = 0;
	DDPCONbits.JTAGEN = 0;

	SYSTEMConfigPerformance(40000000);
    mOSCSetPBDIV(OSC_PB_DIV_2);

	delay_ms(500);
	
	UART1_Init(115200);
	
	delay_ms(500);

	UART1_puts("*******************************\n");
	UART1_puts("* PIC32MX120F032B WAV Jukebox *\n");
	UART1_puts("*******************************\n");

	startWavFile();

	SearchRec f_search;
	FindFirst("*.wav", ATTR_MASK, &f_search);
	//FindNext(&f_search);
	//playWaveFile(f_search.filename);

	while(1)
	{
		playWaveFile(f_search.filename);
		//FindNext(&f_search);
		if (FindNext(&f_search)!= 0)
			FindFirst("*.wav", ATTR_MASK, &f_search);
		
		delay_ms(500);
	}
}

void UART1_Init(unsigned long baudrate)
{
   RPA0R = 0x01; // RA0 - U1TX;
   U1RXR = 0x04; // RB2 - U1RX;
   TRISAbits.TRISA0 = 0;
   TRISBbits.TRISB2 = 1;
   U1BRG = (PBS/4/baudrate) - 1;
   U1MODE = 0x8008;
   U1STAbits.UTXEN = 1;
   U1STAbits.URXEN = 1;
}


void UART1_putc(unsigned char inputc)
{
   while(U1STAbits.UTXBF);
   U1TXREG = inputc;
}

void UART1_puts(unsigned char* string)
{
    while(*string)
      UART1_putc(*string++);
}

void UART1_puts_N(unsigned char* string)
{
    while(*string != '\0')
      UART1_putc(*string++);
}

void delay_ms(unsigned int count)
{
	T1CON = 0x8030;		// turn on timer, prescaler to 256
	while(count--)
	{
		TMR1 = 0;
		while(TMR1 < 0x4e);
	}
	T1CONbits.ON = 0;
}



	
	
	
	

	

	
